#!/usr/bin/python
import numpy, re, pickle, glob, os
from classGraph import Graph, Data
import mappingTools
import pdb

experiments_settings = [ {'combine_paths': True,
                          'limit_pattern': 0,
                          'graph_filename': '/home/galbrun/redescriptors/relational/sandbox/kinship/data.bmg',
                          'out_rep': "/home/galbrun/redescriptors/relational/sandbox/results/"}
                         ]

parameters = {}
parameters['max_paths']=1000000
parameters['max_time']=60
parameters['try_extend']=1
parameters['try_init']=5 # 3
parameters['alt_longer']=2 # 3
parameters['min_examples']=3
parameters['thres_support']=0.2
parameters['thres_acc']=1
parameters['max_eq']=4
parameters['max_nd']=10
parameters['combine_paths'] = False
parameters['include_supers'] = False #True
parameters['prune_idems'] = True
parameters['limit_pattern'] = 1
parameters['id_exp'] = "tmp"
parameters['out_rep']="/home/galbrun/redescriptors/relational/sandbox/outputs/test/"

kinlinks = dict([("kinlink=%d" % i, 'cat') for i in range(24)]) 

parameters['relevant_atts'] = {Graph.ND: {'sex':'cat', 'age':'num', 'relevant':'cat'},
                               Graph.EG: {'genealink=spouse':'cat',
                                          'genealink=parent':'cat'}}
parameters['relevant_atts'][Graph.EG].update(kinlinks)

for ei, experiment_settings in enumerate(experiments_settings):
    parameters.update(experiment_settings)

    if not os.path.exists(parameters['out_rep']):
        os.makedirs(parameters['out_rep'])
       
    print "##############SETTINGS (EXP %d)" % ei
    print "######################"
    for (k,v) in parameters.items():
        print k, ":", v
    print "######################"

    fp = open(parameters['graph_filename'])
    data = Data(parameters['relevant_atts'])
    data.readBMG(fp)
    fp.close()

    # tmp_lo = []
    # for filepick in glob.glob(out_rep+"pickle_pat_tmp*.bmg"):
    #     fp = open(filepick, 'r')
    #     tmp_lo.append(pickle.load(fp))
    #     fp.close()
      
    cdesc_list = kinlinks.keys()
    cdesc_list = ['kinlink=21']
    
    redid = 0
    for cdesc_att in cdesc_list:
        print "###########################"
        edges = data.graph.elems_pred[Graph.EG].get(cdesc_att,{}).get('EG',[])
        if len(edges) < parameters['min_examples']:
            print "Too few examples for %s (%d)..." % (cdesc_att, len(edges))
            continue

        inv_att = {Graph.EG: {},               
                   Graph.ND: dict(parameters['relevant_atts'][Graph.ND])}
        match_att = "^"+cdesc_att.split("=")[0]+"=.*$"
        for edge_att, type_att in parameters['relevant_atts'][Graph.EG].items():
            if not re.match(match_att, edge_att):
                inv_att[Graph.EG][edge_att] = type_att

        query_nodes = {'T_A': True, 'T_Z': True}

        parameters['id_exp'] = cdesc_att
        print "Let's see %s (%d)..." % (parameters['id_exp'], len(edges))
        
        essential, details = mappingTools.searchPattern(data.graph, edges, inv_att, parameters)
        mappingTools.writeShortResults(parameters, edges, details)
        
